;ティラノスクリプト向けVRoidプラグイン 使用サンプル
*start

[layopt layer=0 visible=true]
[layopt layer=1 visible=true]

;プラグインの読み込み
[plugin name=vrm]

モデルの読み込み中...
[VRoid_new layerID="VRoid" layer=1 visible=false limitFPS=auto]

;光源の種類を変更してレイヤーを作成する場合はこっちを有効にして、上を注釈にする。
;[VRoid_new layerID="VRoid" layer=1 lightType="ambient" visible=false]

;カメラポジションの変更（モデルの大きさによって要調整）
[VRoid_camera_move layerID="VRoid" y=1.3 z=1.5]

;ライトの位置を調整
[VRoid_light layerID="VRoid" x=-1 y=1 z=0.5]

;3Dモデルの読み込み
[VRoid_load modelID="model1" storage="AliciaSolid.vrm"]

;3Dモデルをレイヤーに設定
[VRoid_add layerID="VRoid" modelID="model1" pose="pose1001" lookingCamera=true]

;ブリンクの詳細設定ファイルを読み込む
[VRoid_import_blinkSetting storage="alicia.json" modelID="model1"]

[cm]
[layopt layer=message0 visible=false]

;背景の読み込み
[VRoid_img_add layerID="VRoid" imgID="background" storage="./data/bgimage/room.jpg" y=1 z=-2 scaleX=3 scaleY=3]

;VRoidレイヤーをフェードイン
[VRoid_layer_show layerID="VRoid" time=1000 method="fadeIn"]

;元の背景を削除
[freeimage layer=base]

[wait time=500]

*command
[glink target="select1" color="btn_15_black" text="カメラの移動・回転" size=30 width=400 x=50 y=50]
[glink target="select2" color="btn_15_black" text="モデルの移動・回転" size=30 width=400 x=50 y=160]
[glink target="select3" color="btn_15_black" text="ポーズ・表情の変更" size=30 width=400 x=50 y=270]
[glink target="select4" color="btn_15_black" text="ライトと風機能のデモ"   size=30 width=400 x=50 y=380]
[glink target="select5" color="btn_15_black" text="エフェクト機能のデモ"   size=30 width=400 x=50 y=495]
[glink target="select6" color="btn_15_black" text="開発用ツールの起動" size=30 width=400 x=50 y=600]
[s]

*select1
;===========================================
;
;    カメラの移動・回転
;
;===========================================

[layopt layer="message0" visible=true]

カメラを移動と回転をします。[p]
[layopt layer="message0" visible=false]

[VRoid_camera_move layerID="VRoid" x=0.5 time=2000]
[VRoid_camera_move layerID="VRoid" x=-1.0 time=2000]
[VRoid_camera_move layerID="VRoid" x=0 time=2000]

;+=や-=などの相対指定も可能
[VRoid_camera_move layerID="VRoid" y="+=0.5" time=2000]
[VRoid_camera_move layerID="VRoid" y="-=1.0" time=2000]
[VRoid_camera_move layerID="VRoid" y="+=0.5" time=2000]

[VRoid_camera_move layerID="VRoid" z="+=0.5" time=2000]
[VRoid_camera_move layerID="VRoid" z="-=1.0" time=2000]
[VRoid_camera_move layerID="VRoid" z="+=0.5" time=2000]

[VRoid_camera_move layerID="VRoid" rotX=0.5 time=2000]
[VRoid_camera_move layerID="VRoid" rotX=-1.0 time=2000]
[VRoid_camera_move layerID="VRoid" rotX=0 time=2000]

[VRoid_camera_move layerID="VRoid" rotY=0.5 time=2000]
[VRoid_camera_move layerID="VRoid" rotY=-1.0 time=2000]
[VRoid_camera_move layerID="VRoid" rotY=0 time=2000]

;rotationはπ（3.14）を指定することで約半周します。
[VRoid_camera_move layerID="VRoid" rotZ=3.14 time=2000]
[VRoid_camera_move layerID="VRoid" rotZ=-6.28 time=2000]
[VRoid_camera_move layerID="VRoid" rotZ=0 time=2000]

[jump target=command]
[s]



*select2
;===========================================
;
;    モデルの移動・回転
;
;===========================================

[layopt layer="message0" visible=true]

モデルを移動と回転をします。[r]
カメラの移動とは違い、移動によってモデルの揺れ物が揺れます。[p]

[layopt layer="message0" visible=false]

[VRoid_model_move modelID="model1" z=-0.5 easing="easeOutBack" time=2000]
[wait time=500]
[VRoid_model_move modelID="model1" x=0.1 z=0.5 easing="easeOutBack" time=2000]
[wait time=500]
[VRoid_model_move modelID="model1" x=0 z=-1 easing="easeOutBack" time=2000]

[wait time=1000]

;rotationはπ（3.14）を指定することで約半周します。
[VRoid_model_move modelID="model1" rotY=3.14 easing="easeOutBack" time=2000]
[wait time=500]
[VRoid_model_move modelID="model1" rotX=6.28 easing="easeOutBack" time=2000]
[wait time=500]
[VRoid_model_move modelID="model1" rotX=0 rotY=0 easing="easeOutBack" time=2000]

[wait time=1000]

[VRoid_model_move modelID="model1" z=0 easing="easeOutBack" time=2000]

[wait time=500]

[jump target=command]
[s]



*select3
;===========================================
;
;    ポーズ・表情の変更
;
;===========================================

[layopt layer="message0" visible=true]

デフォルトで400種類以上のポーズデータが利用可能です。[p]

イージング関数による自然な動きでポーズの変更が可能です。[p]

[VRoid_pose modelID="model1" pose="pose1002" time=1000]
[VRoid_pose modelID="model1" pose="pose1003" time=1000]
[VRoid_pose modelID="model1" pose="pose1004" time=1000]

プラグイン同梱のポーズを編集したり、オリジナルのポーズをインポートする機能もあります。[p]

また、ポーズと同時に表情の変更も可能です。[p]

[VRoid_pose modelID="model1" pose="pose2005" emo="happy" time=1000]

もちろん表情だけ別に変更することもできます。[p]

[VRoid_emo modelID="model1" emo="relaxed" time=1000]
[wait time=500]
[VRoid_pose modelID="model1" pose="pose1001" emo="default" time=1000]


[layopt layer="message0" visible=false]
[jump target=command]
[s]



*select4
;===========================================
;
;    ライトと風機能のデモ
;
;===========================================

[layopt layer="message0" visible=true]

ライトの位置と色合いを調整して夕日のようにします。[p]

[VRoid_light layerID="VRoid" x=-1.5 y=0.5 z=-1 g=0.5 b=0.5 val=1.5 time=2000]

一度戻します。[p]

[VRoid_light layerID="VRoid" x=-1 y=1 z=0.5 r=1 g=1 b=1 val=1 time=500]

風を発生させそれっぽく演出してみます。[p]

[layopt layer="message0" visible=false]

[VRoid_wind modelID="model1" x=1 y=0.5 z=-0.5  val=0.8 speed=1]
[VRoid_light layerID="VRoid" x=-1.5 y=0.5 z=-1 g=0.5 b=0.5 val=1.2 time=5000 wait=false]
[filter layer=0 brightness=80 hue=145 saturate=230]
[image storage="rouka.jpg" layer=0 folder="bgimage" time=5000]

[layopt layer="message0" visible=true]

元に戻します。[p]


[VRoid_light layerID="VRoid" x=-1 y=1 z=0.5 r=1 g=1 b=1 val=1 time=500 wait=false]
[freeimage layer=0 time=500]
[free_filter]
[VRoid_stop_wind modelID="model1"]

[layopt layer="message0" visible=false]
[jump target=command]
[s]



*select5
;===========================================
;
;    エフェクト機能のデモ
;
;===========================================

[layopt layer="message0" visible=true]
VRoidプラグインV2から[r]
エフェクト機能をサポートしています。[p]

エフェクト機能を使用し、[r]
様々な画面効果を適用することが可能です。[p]

それぞれのエフェクトにパラメーターを設定することで[r]
多種多様な演出を作り出せます。[p]

※複数のエフェクトを重ねることも可能ですが、[r]
エフェクトによっては重ねる順番により[r]
見た目が異なる場合があります。[p]


[layopt layer="message0" visible=false]

;エフェクトは事前にプリロードを行うと初回適用時の処理が速くなります
[VRoid_effect_preload name=Afterimage]
[VRoid_effect_preload name=Bloom]
[VRoid_effect_preload name=DotScreen]
[VRoid_effect_preload name=Film]
[VRoid_effect_preload name=Glitch]
[VRoid_effect_preload name=RenderPixelated]
[VRoid_effect_preload name=HorizontalBlur]
[VRoid_effect_preload name=Mirror]

[iscript]
	VRoid.three.pose("model1", "pose10" + (Math.floor(Math.random() * 9) + 1) + (Math.floor(Math.random() * 9) + 1), 1000)
	sf.loopID = setInterval(() =>{
		VRoid.three.pose("model1", "pose10" + (Math.floor(Math.random() * 9) + 1) + (Math.floor(Math.random() * 9) + 1), 1000)
	}, 2000);
	f.effectDemo = true
[endscript]

*select_effect
[glink target="effect" x=50 y=36   color="btn_15_black" text="Afterimage"      size=22 width=400 cond="!f.effect1" exp="f.name = 'Afterimage'; f.effect = f.effect1 = true"]
[glink target="effect" x=50 y=36   color="btn_15_blue"  text="Afterimage"      size=22 width=400 cond="f.effect1" exp="f.name = 'Afterimage'; f.effect = f.effect1 = false"]

[glink target="effect" x=50 y=110  color="btn_15_black" text="Bloom"           size=22 width=400 cond="!f.effect2" exp="f.name = 'Bloom'; f.effect = f.effect2 = true"]
[glink target="effect" x=50 y=110  color="btn_15_blue"  text="Bloom"           size=22 width=400 cond="f.effect2" exp="f.name = 'Bloom'; f.effect = f.effect2 = false"]

[glink target="effect" x=50 y=184  color="btn_15_black" text="DotScreen"       size=22 width=400 cond="!f.effect3" exp="f.name = 'DotScreen'; f.effect = f.effect3 = true"]
[glink target="effect" x=50 y=184  color="btn_15_blue"  text="DotScreen"       size=22 width=400 cond="f.effect3" exp="f.name = 'DotScreen'; f.effect = f.effect3 = false"]

[glink target="effect" x=50 y=258  color="btn_15_black" text="Film"            size=22 width=400 cond="!f.effect4" exp="f.name = 'Film'; f.effect = f.effect4 = true"]
[glink target="effect" x=50 y=258  color="btn_15_blue"  text="Film"            size=22 width=400 cond="f.effect4" exp="f.name = 'Film'; f.effect = f.effect4 = false"]

[glink target="effect" x=50 y=332  color="btn_15_black" text="Glitch"          size=22 width=400 cond="!f.effect5" exp="f.name = 'Glitch'; f.effect = f.effect5 = true"]
[glink target="effect" x=50 y=332  color="btn_15_blue"  text="Glitch"          size=22 width=400 cond="f.effect5" exp="f.name = 'Glitch'; f.effect = f.effect5 = false"]

[glink target="effect" x=50 y=406  color="btn_15_black" text="RenderPixelated" size=22 width=400 cond="!f.effect6" exp="f.name = 'RenderPixelated'; f.effect = f.effect6 = true"]
[glink target="effect" x=50 y=406  color="btn_15_blue"  text="RenderPixelated" size=22 width=400 cond="f.effect6" exp="f.name = 'RenderPixelated'; f.effect = f.effect6 = false"]

[glink target="effect" x=50 y=480  color="btn_15_black" text="HorizontalBlur"  size=22 width=400 cond="!f.effect7" exp="f.name = 'HorizontalBlur'; f.effect = f.effect7 = true"]
[glink target="effect" x=50 y=480  color="btn_15_blue"  text="HorizontalBlur"  size=22 width=400 cond="f.effect7" exp="f.name = 'HorizontalBlur'; f.effect = f.effect7 = false"]

[glink target="effect" x=50 y=554  color="btn_15_black" text="Mirror"          size=22 width=400 cond="!f.effect8" exp="f.name = 'Mirror'; f.effect = f.effect8 = true"]
[glink target="effect" x=50 y=554  color="btn_15_blue"  text="Mirror"          size=22 width=400 cond="f.effect8" exp="f.name = 'Mirror'; f.effect = f.effect8 = false"]

[glink target="effect_end" x=50 y=628   color="btn_15_black" text="メニューに戻る" size=22 width=400]
[s]

*effect

[VRoid_effect layerID="VRoid" name="&f.name" cond="f.effect"]
[VRoid_effect_delete layerID="VRoid" name="&f.name" cond="!f.effect"]

[jump target=select_effect]
[s]


*effect_end
[VRoid_effect_delete layerID="VRoid"]
[iscript]
	delete f.effectDemo
	clearInterval(sf.loopID);
[endscript]
[wait time=1000]
[VRoid_pose modelID="model1" emo="default" pose="pose1001" time=1000]
[jump target=command]
[s]



*select6
;===========================================
;
;    開発用ツールの起動
;
;===========================================

[layopt layer="message0" visible=true]
開発用に役立つ「エモーションメイカー」と[r]
「テストカメラ」を起動します。[p]

「テストカメラ」モードではマウスの操作によって[r]
カメラを直感的に変更可能です。[p]

変更したカメラの情報は、[r]
開発者ツールのコンソールに出力されます。[p]

「テストカメラ」起動時はゲームがストップするので[r]
再開したい場合は、右上の「CLOSE」で終了してください。[p]

[layopt layer="message0" visible=false]

;エモーションメイカーとテストカメラの起動
[VRoid_emo_maker modelID="model1"]
[VRoid_camera_test layerID="VRoid" modelID="model1"]

[iscript]
	//エモーションメイカーも強制終了する
	$("#emoMaker").remove();
[endscript]


;元のカメラポジションに戻す
[VRoid_camera_move layerID="VRoid" x=0 y=1.3 z=1.5 rotX=0 rotY=0 rotZ=0 time=1000 wait=false]

;ポーズと表情をデフォルトに戻す
[VRoid_pose modelID="model1" emo="default" pose="pose1001" time=1000]

[jump target=command]
[s]
